Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# AlgorithmParameters< PARENT, T > Class Template Reference

Inheritance diagram for AlgorithmParameters< PARENT, T >:

List of all members.

## Detailed Description

### template<class PARENT, class T>
class AlgorithmParameters< PARENT, T >

Definition at line 308 of file algparam.h.

## Public Member Functions
| AlgorithmParameters (const PARENT &parent, const char *name, const T &value, bool throwIfNotUsed)
| AlgorithmParameters (const AlgorithmParameters &copy)
template<class R>
AlgorithmParameters< AlgorithmParameters< PARENT, T >, R > | operator() (const char *name, const R &value) const
template<class R>
AlgorithmParameters< AlgorithmParameters< PARENT, T >, R > | operator() (const char *name, const R &value, bool throwIfNotUsed) const
void | AssignValue (const char *name, const std::type_info &valueType, void *pValue) const
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| to be implemented by derived classes, users should use one of the above functions instead
template<class T>
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T>
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T>
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
## Static Public Member Functions
static void __cdecl | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch
## Protected Attributes
T | m_value
const char * | m_name
bool | m_throwIfNotUsed
bool | m_used

## Member Function Documentation

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value
| ) | const`[inline, inherited]`

| get a named value with type int used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case) Definition at line 278 of file cryptlib.h. Referenced by InvertibleRWFunction::GenerateRandom(), InvertibleRSAFunction::GenerateRandom(), InvertibleRabinFunction::GenerateRandom(), InvertibleLUCFunction::GenerateRandom(), DL_GroupParameters_IntegerBased::GenerateRandom(), DL_GroupParameters_DSA::GenerateRandom(), InvertibleESIGNFunction::GenerateRandom(), and Integer::GenerateRandomNoThrow().

The documentation for this class was generated from the following file:

- algparam.h